# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.admin.v1.model.reset_password_request import ResetPasswordRequest
from lark_oapi.api.admin.v1.model.reset_password_response import ResetPasswordResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Password(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def reset(self, request: ResetPasswordRequest, option: RequestOption = RequestOption()) -> ResetPasswordResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ResetPasswordResponse = JSON.unmarshal(str(resp.content, UTF_8), ResetPasswordResponse)
        response.raw = resp

        return response
