# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.application.v6.model.list_application_feedback_request import ListApplicationFeedbackRequest
from lark_oapi.api.application.v6.model.list_application_feedback_response import ListApplicationFeedbackResponse
from lark_oapi.api.application.v6.model.patch_application_feedback_request import PatchApplicationFeedbackRequest
from lark_oapi.api.application.v6.model.patch_application_feedback_response import PatchApplicationFeedbackResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class ApplicationFeedback(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def list(self, request: ListApplicationFeedbackRequest,
             option: RequestOption = RequestOption()) -> ListApplicationFeedbackResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListApplicationFeedbackResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   ListApplicationFeedbackResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchApplicationFeedbackRequest,
              option: RequestOption = RequestOption()) -> PatchApplicationFeedbackResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchApplicationFeedbackResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    PatchApplicationFeedbackResponse)
        response.raw = resp

        return response
