# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.attendance.v1.model.create_group_request import CreateGroupRequest
from lark_oapi.api.attendance.v1.model.create_group_response import CreateGroupResponse
from lark_oapi.api.attendance.v1.model.delete_group_request import DeleteGroupRequest
from lark_oapi.api.attendance.v1.model.delete_group_response import DeleteGroupResponse
from lark_oapi.api.attendance.v1.model.get_group_request import GetGroupRequest
from lark_oapi.api.attendance.v1.model.get_group_response import GetGroupResponse
from lark_oapi.api.attendance.v1.model.list_group_request import ListGroupRequest
from lark_oapi.api.attendance.v1.model.list_group_response import ListGroupResponse
from lark_oapi.api.attendance.v1.model.search_group_request import SearchGroupRequest
from lark_oapi.api.attendance.v1.model.search_group_response import SearchGroupResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Group(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateGroupRequest, option: RequestOption = RequestOption()) -> CreateGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateGroupResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteGroupRequest, option: RequestOption = RequestOption()) -> DeleteGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteGroupResponse)
        response.raw = resp

        return response

    def get(self, request: GetGroupRequest, option: RequestOption = RequestOption()) -> GetGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), GetGroupResponse)
        response.raw = resp

        return response

    def list(self, request: ListGroupRequest, option: RequestOption = RequestOption()) -> ListGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), ListGroupResponse)
        response.raw = resp

        return response

    def search(self, request: SearchGroupRequest, option: RequestOption = RequestOption()) -> SearchGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SearchGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), SearchGroupResponse)
        response.raw = resp

        return response
