# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.baike.v1.model.create_draft_request import CreateDraftRequest
from lark_oapi.api.baike.v1.model.create_draft_response import CreateDraftResponse
from lark_oapi.api.baike.v1.model.update_draft_request import UpdateDraftRequest
from lark_oapi.api.baike.v1.model.update_draft_response import UpdateDraftResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Draft(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateDraftRequest, option: RequestOption = RequestOption()) -> CreateDraftResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateDraftResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateDraftResponse)
        response.raw = resp

        return response

    def update(self, request: UpdateDraftRequest, option: RequestOption = RequestOption()) -> UpdateDraftResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UpdateDraftResponse = JSON.unmarshal(str(resp.content, UTF_8), UpdateDraftResponse)
        response.raw = resp

        return response
