# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.bitable.v1.model.copy_app_dashboard_request import CopyAppDashboardRequest
from lark_oapi.api.bitable.v1.model.copy_app_dashboard_response import CopyAppDashboardResponse
from lark_oapi.api.bitable.v1.model.list_app_dashboard_request import ListAppDashboardRequest
from lark_oapi.api.bitable.v1.model.list_app_dashboard_response import ListAppDashboardResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class AppDashboard(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def copy(self, request: CopyAppDashboardRequest,
             option: RequestOption = RequestOption()) -> CopyAppDashboardResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CopyAppDashboardResponse = JSON.unmarshal(str(resp.content, UTF_8), CopyAppDashboardResponse)
        response.raw = resp

        return response

    def list(self, request: ListAppDashboardRequest,
             option: RequestOption = RequestOption()) -> ListAppDashboardResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListAppDashboardResponse = JSON.unmarshal(str(resp.content, UTF_8), ListAppDashboardResponse)
        response.raw = resp

        return response
