# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.bitable.v1.model.batch_create_app_role_member_request import BatchCreateAppRoleMemberRequest
from lark_oapi.api.bitable.v1.model.batch_create_app_role_member_response import BatchCreateAppRoleMemberResponse
from lark_oapi.api.bitable.v1.model.batch_delete_app_role_member_request import BatchDeleteAppRoleMemberRequest
from lark_oapi.api.bitable.v1.model.batch_delete_app_role_member_response import BatchDeleteAppRoleMemberResponse
from lark_oapi.api.bitable.v1.model.create_app_role_member_request import CreateAppRoleMemberRequest
from lark_oapi.api.bitable.v1.model.create_app_role_member_response import CreateAppRoleMemberResponse
from lark_oapi.api.bitable.v1.model.delete_app_role_member_request import DeleteAppRoleMemberRequest
from lark_oapi.api.bitable.v1.model.delete_app_role_member_response import DeleteAppRoleMemberResponse
from lark_oapi.api.bitable.v1.model.list_app_role_member_request import ListAppRoleMemberRequest
from lark_oapi.api.bitable.v1.model.list_app_role_member_response import ListAppRoleMemberResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class AppRoleMember(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def batch_create(self, request: BatchCreateAppRoleMemberRequest,
                     option: RequestOption = RequestOption()) -> BatchCreateAppRoleMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchCreateAppRoleMemberResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    BatchCreateAppRoleMemberResponse)
        response.raw = resp

        return response

    def batch_delete(self, request: BatchDeleteAppRoleMemberRequest,
                     option: RequestOption = RequestOption()) -> BatchDeleteAppRoleMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchDeleteAppRoleMemberResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    BatchDeleteAppRoleMemberResponse)
        response.raw = resp

        return response

    def create(self, request: CreateAppRoleMemberRequest,
               option: RequestOption = RequestOption()) -> CreateAppRoleMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateAppRoleMemberResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateAppRoleMemberResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteAppRoleMemberRequest,
               option: RequestOption = RequestOption()) -> DeleteAppRoleMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteAppRoleMemberResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteAppRoleMemberResponse)
        response.raw = resp

        return response

    def list(self, request: ListAppRoleMemberRequest,
             option: RequestOption = RequestOption()) -> ListAppRoleMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListAppRoleMemberResponse = JSON.unmarshal(str(resp.content, UTF_8), ListAppRoleMemberResponse)
        response.raw = resp

        return response
