# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.bitable.v1.model.get_app_table_form_request import GetAppTableFormRequest
from lark_oapi.api.bitable.v1.model.get_app_table_form_response import GetAppTableFormResponse
from lark_oapi.api.bitable.v1.model.patch_app_table_form_request import PatchAppTableFormRequest
from lark_oapi.api.bitable.v1.model.patch_app_table_form_response import PatchAppTableFormResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class AppTableForm(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetAppTableFormRequest, option: RequestOption = RequestOption()) -> GetAppTableFormResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetAppTableFormResponse = JSON.unmarshal(str(resp.content, UTF_8), GetAppTableFormResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchAppTableFormRequest,
              option: RequestOption = RequestOption()) -> PatchAppTableFormResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchAppTableFormResponse = JSON.unmarshal(str(resp.content, UTF_8), PatchAppTableFormResponse)
        response.raw = resp

        return response
