# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.calendar.v4.model.generate_caldav_conf_setting_request import GenerateCaldavConfSettingRequest
from lark_oapi.api.calendar.v4.model.generate_caldav_conf_setting_response import GenerateCaldavConfSettingResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Setting(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def generate_caldav_conf(self, request: GenerateCaldavConfSettingRequest,
                             option: RequestOption = RequestOption()) -> GenerateCaldavConfSettingResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GenerateCaldavConfSettingResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     GenerateCaldavConfSettingResponse)
        response.raw = resp

        return response
