# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.calendar.v4.model.create_timeoff_event_request import CreateTimeoffEventRequest
from lark_oapi.api.calendar.v4.model.create_timeoff_event_response import CreateTimeoffEventResponse
from lark_oapi.api.calendar.v4.model.delete_timeoff_event_request import DeleteTimeoffEventRequest
from lark_oapi.api.calendar.v4.model.delete_timeoff_event_response import DeleteTimeoffEventResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class TimeoffEvent(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateTimeoffEventRequest,
               option: RequestOption = RequestOption()) -> CreateTimeoffEventResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateTimeoffEventResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateTimeoffEventResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteTimeoffEventRequest,
               option: RequestOption = RequestOption()) -> DeleteTimeoffEventResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteTimeoffEventResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteTimeoffEventResponse)
        response.raw = resp

        return response
