# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core.enum import HttpMethod, AccessTokenType
from lark_oapi.core.model import BaseRequest
from .department import Department


class UpdateDepartmentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.department_id: Optional[str] = None
        self.request_body: Optional[Department] = None

    @staticmethod
    def builder() -> "UpdateDepartmentRequestBuilder":
        return UpdateDepartmentRequestBuilder()


class UpdateDepartmentRequestBuilder(object):

    def __init__(self, update_department_request: UpdateDepartmentRequest = UpdateDepartmentRequest()) -> None:
        update_department_request.http_method = HttpMethod.PUT
        update_department_request.uri = "/open-apis/contact/v3/departments/:department_id"
        update_department_request.token_types = {AccessTokenType.TENANT}
        self._update_department_request: UpdateDepartmentRequest = update_department_request

    def user_id_type(self, user_id_type: str) -> "UpdateDepartmentRequestBuilder":
        self._update_department_request.user_id_type = user_id_type
        self._update_department_request.queries["user_id_type"] = str(user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "UpdateDepartmentRequestBuilder":
        self._update_department_request.department_id_type = department_id_type
        self._update_department_request.queries["department_id_type"] = str(department_id_type)
        return self

    def department_id(self, department_id: str) -> "UpdateDepartmentRequestBuilder":
        self._update_department_request.department_id = department_id
        self._update_department_request.paths["department_id"] = department_id
        return self

    def request_body(self, request_body: Department) -> "UpdateDepartmentRequestBuilder":
        self._update_department_request.request_body = request_body
        self._update_department_request.body = request_body
        return self

    def build(self) -> UpdateDepartmentRequest:
        return self._update_department_request
