# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v1.model.get_country_region_request import GetCountryRegionRequest
from lark_oapi.api.corehr.v1.model.get_country_region_response import GetCountryRegionResponse
from lark_oapi.api.corehr.v1.model.list_country_region_request import ListCountryRegionRequest
from lark_oapi.api.corehr.v1.model.list_country_region_response import ListCountryRegionResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class CountryRegion(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetCountryRegionRequest,
            option: RequestOption = RequestOption()) -> GetCountryRegionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetCountryRegionResponse = JSON.unmarshal(str(resp.content, UTF_8), GetCountryRegionResponse)
        response.raw = resp

        return response

    def list(self, request: ListCountryRegionRequest,
             option: RequestOption = RequestOption()) -> ListCountryRegionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListCountryRegionResponse = JSON.unmarshal(str(resp.content, UTF_8), ListCountryRegionResponse)
        response.raw = resp

        return response
