# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v1.model.get_currency_request import GetCurrencyRequest
from lark_oapi.api.corehr.v1.model.get_currency_response import GetCurrencyResponse
from lark_oapi.api.corehr.v1.model.list_currency_request import ListCurrencyRequest
from lark_oapi.api.corehr.v1.model.list_currency_response import ListCurrencyResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Currency(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetCurrencyRequest, option: RequestOption = RequestOption()) -> GetCurrencyResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetCurrencyResponse = JSON.unmarshal(str(resp.content, UTF_8), GetCurrencyResponse)
        response.raw = resp

        return response

    def list(self, request: ListCurrencyRequest, option: RequestOption = RequestOption()) -> ListCurrencyResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListCurrencyResponse = JSON.unmarshal(str(resp.content, UTF_8), ListCurrencyResponse)
        response.raw = resp

        return response
