# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v1.model.get_by_param_custom_field_request import GetByParamCustomFieldRequest
from lark_oapi.api.corehr.v1.model.get_by_param_custom_field_response import GetByParamCustomFieldResponse
from lark_oapi.api.corehr.v1.model.list_object_api_name_custom_field_request import ListObjectApiNameCustomFieldRequest
from lark_oapi.api.corehr.v1.model.list_object_api_name_custom_field_response import \
    ListObjectApiNameCustomFieldResponse
from lark_oapi.api.corehr.v1.model.query_custom_field_request import QueryCustomFieldRequest
from lark_oapi.api.corehr.v1.model.query_custom_field_response import QueryCustomFieldResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class CustomField(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get_by_param(self, request: GetByParamCustomFieldRequest,
                     option: RequestOption = RequestOption()) -> GetByParamCustomFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetByParamCustomFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 GetByParamCustomFieldResponse)
        response.raw = resp

        return response

    def list_object_api_name(self, request: ListObjectApiNameCustomFieldRequest,
                             option: RequestOption = RequestOption()) -> ListObjectApiNameCustomFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListObjectApiNameCustomFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        ListObjectApiNameCustomFieldResponse)
        response.raw = resp

        return response

    def query(self, request: QueryCustomFieldRequest,
              option: RequestOption = RequestOption()) -> QueryCustomFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: QueryCustomFieldResponse = JSON.unmarshal(str(resp.content, UTF_8), QueryCustomFieldResponse)
        response.raw = resp

        return response
