# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v1.model.list_security_group_request import ListSecurityGroupRequest
from lark_oapi.api.corehr.v1.model.list_security_group_response import ListSecurityGroupResponse
from lark_oapi.api.corehr.v1.model.query_security_group_request import QuerySecurityGroupRequest
from lark_oapi.api.corehr.v1.model.query_security_group_response import QuerySecurityGroupResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class SecurityGroup(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def list(self, request: ListSecurityGroupRequest,
             option: RequestOption = RequestOption()) -> ListSecurityGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListSecurityGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), ListSecurityGroupResponse)
        response.raw = resp

        return response

    def query(self, request: QuerySecurityGroupRequest,
              option: RequestOption = RequestOption()) -> QuerySecurityGroupResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: QuerySecurityGroupResponse = JSON.unmarshal(str(resp.content, UTF_8), QuerySecurityGroupResponse)
        response.raw = resp

        return response
