# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v1.model.get_subdivision_request import GetSubdivisionRequest
from lark_oapi.api.corehr.v1.model.get_subdivision_response import GetSubdivisionResponse
from lark_oapi.api.corehr.v1.model.list_subdivision_request import ListSubdivisionRequest
from lark_oapi.api.corehr.v1.model.list_subdivision_response import ListSubdivisionResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Subdivision(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetSubdivisionRequest, option: RequestOption = RequestOption()) -> GetSubdivisionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetSubdivisionResponse = JSON.unmarshal(str(resp.content, UTF_8), GetSubdivisionResponse)
        response.raw = resp

        return response

    def list(self, request: ListSubdivisionRequest, option: RequestOption = RequestOption()) -> ListSubdivisionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListSubdivisionResponse = JSON.unmarshal(str(resp.content, UTF_8), ListSubdivisionResponse)
        response.raw = resp

        return response
