# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v1.model.get_subregion_request import GetSubregionRequest
from lark_oapi.api.corehr.v1.model.get_subregion_response import GetSubregionResponse
from lark_oapi.api.corehr.v1.model.list_subregion_request import ListSubregionRequest
from lark_oapi.api.corehr.v1.model.list_subregion_response import ListSubregionResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Subregion(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetSubregionRequest, option: RequestOption = RequestOption()) -> GetSubregionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetSubregionResponse = JSON.unmarshal(str(resp.content, UTF_8), GetSubregionResponse)
        response.raw = resp

        return response

    def list(self, request: ListSubregionRequest, option: RequestOption = RequestOption()) -> ListSubregionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListSubregionResponse = JSON.unmarshal(str(resp.content, UTF_8), ListSubregionResponse)
        response.raw = resp

        return response
