# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v2.model.parents_department_request import ParentsDepartmentRequest
from lark_oapi.api.corehr.v2.model.parents_department_response import ParentsDepartmentResponse
from lark_oapi.api.corehr.v2.model.search_department_request import SearchDepartmentRequest
from lark_oapi.api.corehr.v2.model.search_department_response import SearchDepartmentResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Department(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def parents(self, request: ParentsDepartmentRequest,
                option: RequestOption = RequestOption()) -> ParentsDepartmentResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ParentsDepartmentResponse = JSON.unmarshal(str(resp.content, UTF_8), ParentsDepartmentResponse)
        response.raw = resp

        return response

    def search(self, request: SearchDepartmentRequest,
               option: RequestOption = RequestOption()) -> SearchDepartmentResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SearchDepartmentResponse = JSON.unmarshal(str(resp.content, UTF_8), SearchDepartmentResponse)
        response.raw = resp

        return response
