# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.corehr.v2.model.search_employee_request import SearchEmployeeRequest
from lark_oapi.api.corehr.v2.model.search_employee_response import SearchEmployeeResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Employee(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def search(self, request: SearchEmployeeRequest, option: RequestOption = RequestOption()) -> SearchEmployeeResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SearchEmployeeResponse = JSON.unmarshal(str(resp.content, UTF_8), SearchEmployeeResponse)
        response.raw = resp

        return response
