# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.drive.v1.model.create_file_subscription_request import CreateFileSubscriptionRequest
from lark_oapi.api.drive.v1.model.create_file_subscription_response import CreateFileSubscriptionResponse
from lark_oapi.api.drive.v1.model.get_file_subscription_request import GetFileSubscriptionRequest
from lark_oapi.api.drive.v1.model.get_file_subscription_response import GetFileSubscriptionResponse
from lark_oapi.api.drive.v1.model.patch_file_subscription_request import PatchFileSubscriptionRequest
from lark_oapi.api.drive.v1.model.patch_file_subscription_response import PatchFileSubscriptionResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class FileSubscription(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateFileSubscriptionRequest,
               option: RequestOption = RequestOption()) -> CreateFileSubscriptionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateFileSubscriptionResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  CreateFileSubscriptionResponse)
        response.raw = resp

        return response

    def get(self, request: GetFileSubscriptionRequest,
            option: RequestOption = RequestOption()) -> GetFileSubscriptionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetFileSubscriptionResponse = JSON.unmarshal(str(resp.content, UTF_8), GetFileSubscriptionResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchFileSubscriptionRequest,
              option: RequestOption = RequestOption()) -> PatchFileSubscriptionResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchFileSubscriptionResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 PatchFileSubscriptionResponse)
        response.raw = resp

        return response
