# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.drive.v1.model.get_permission_public_request import GetPermissionPublicRequest
from lark_oapi.api.drive.v1.model.get_permission_public_response import GetPermissionPublicResponse
from lark_oapi.api.drive.v1.model.patch_permission_public_request import PatchPermissionPublicRequest
from lark_oapi.api.drive.v1.model.patch_permission_public_response import PatchPermissionPublicResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class PermissionPublic(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetPermissionPublicRequest,
            option: RequestOption = RequestOption()) -> GetPermissionPublicResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetPermissionPublicResponse = JSON.unmarshal(str(resp.content, UTF_8), GetPermissionPublicResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchPermissionPublicRequest,
              option: RequestOption = RequestOption()) -> PatchPermissionPublicResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchPermissionPublicResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 PatchPermissionPublicResponse)
        response.raw = resp

        return response
