# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.ehr.v1.model.list_employee_request import ListEmployeeRequest
from lark_oapi.api.ehr.v1.model.list_employee_response import ListEmployeeResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Employee(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def list(self, request: ListEmployeeRequest, option: RequestOption = RequestOption()) -> ListEmployeeResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListEmployeeResponse = JSON.unmarshal(str(resp.content, UTF_8), ListEmployeeResponse)
        response.raw = resp

        return response
