# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.helpdesk.v1.model.create_agent_schedule_request import CreateAgentScheduleRequest
from lark_oapi.api.helpdesk.v1.model.create_agent_schedule_response import CreateAgentScheduleResponse
from lark_oapi.api.helpdesk.v1.model.list_agent_schedule_request import ListAgentScheduleRequest
from lark_oapi.api.helpdesk.v1.model.list_agent_schedule_response import ListAgentScheduleResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class AgentSchedule(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateAgentScheduleRequest,
               option: RequestOption = RequestOption()) -> CreateAgentScheduleResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateAgentScheduleResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateAgentScheduleResponse)
        response.raw = resp

        return response

    def list(self, request: ListAgentScheduleRequest,
             option: RequestOption = RequestOption()) -> ListAgentScheduleResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListAgentScheduleResponse = JSON.unmarshal(str(resp.content, UTF_8), ListAgentScheduleResponse)
        response.raw = resp

        return response
