# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.helpdesk.v1.model.subscribe_event_request import SubscribeEventRequest
from lark_oapi.api.helpdesk.v1.model.subscribe_event_response import SubscribeEventResponse
from lark_oapi.api.helpdesk.v1.model.unsubscribe_event_request import UnsubscribeEventRequest
from lark_oapi.api.helpdesk.v1.model.unsubscribe_event_response import UnsubscribeEventResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Event(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def subscribe(self, request: SubscribeEventRequest,
                  option: RequestOption = RequestOption()) -> SubscribeEventResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SubscribeEventResponse = JSON.unmarshal(str(resp.content, UTF_8), SubscribeEventResponse)
        response.raw = resp

        return response

    def unsubscribe(self, request: UnsubscribeEventRequest,
                    option: RequestOption = RequestOption()) -> UnsubscribeEventResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UnsubscribeEventResponse = JSON.unmarshal(str(resp.content, UTF_8), UnsubscribeEventResponse)
        response.raw = resp

        return response
