# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.helpdesk.v1.model.create_ticket_customized_field_request import CreateTicketCustomizedFieldRequest
from lark_oapi.api.helpdesk.v1.model.create_ticket_customized_field_response import CreateTicketCustomizedFieldResponse
from lark_oapi.api.helpdesk.v1.model.delete_ticket_customized_field_request import DeleteTicketCustomizedFieldRequest
from lark_oapi.api.helpdesk.v1.model.delete_ticket_customized_field_response import DeleteTicketCustomizedFieldResponse
from lark_oapi.api.helpdesk.v1.model.get_ticket_customized_field_request import GetTicketCustomizedFieldRequest
from lark_oapi.api.helpdesk.v1.model.get_ticket_customized_field_response import GetTicketCustomizedFieldResponse
from lark_oapi.api.helpdesk.v1.model.list_ticket_customized_field_request import ListTicketCustomizedFieldRequest
from lark_oapi.api.helpdesk.v1.model.list_ticket_customized_field_response import ListTicketCustomizedFieldResponse
from lark_oapi.api.helpdesk.v1.model.patch_ticket_customized_field_request import PatchTicketCustomizedFieldRequest
from lark_oapi.api.helpdesk.v1.model.patch_ticket_customized_field_response import PatchTicketCustomizedFieldResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class TicketCustomizedField(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateTicketCustomizedFieldRequest,
               option: RequestOption = RequestOption()) -> CreateTicketCustomizedFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateTicketCustomizedFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       CreateTicketCustomizedFieldResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteTicketCustomizedFieldRequest,
               option: RequestOption = RequestOption()) -> DeleteTicketCustomizedFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteTicketCustomizedFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       DeleteTicketCustomizedFieldResponse)
        response.raw = resp

        return response

    def get(self, request: GetTicketCustomizedFieldRequest,
            option: RequestOption = RequestOption()) -> GetTicketCustomizedFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetTicketCustomizedFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    GetTicketCustomizedFieldResponse)
        response.raw = resp

        return response

    def list(self, request: ListTicketCustomizedFieldRequest,
             option: RequestOption = RequestOption()) -> ListTicketCustomizedFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListTicketCustomizedFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     ListTicketCustomizedFieldResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchTicketCustomizedFieldRequest,
              option: RequestOption = RequestOption()) -> PatchTicketCustomizedFieldResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchTicketCustomizedFieldResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                      PatchTicketCustomizedFieldResponse)
        response.raw = resp

        return response
