# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.hire.v1.model.get_attachment_request import GetAttachmentRequest
from lark_oapi.api.hire.v1.model.get_attachment_response import GetAttachmentResponse
from lark_oapi.api.hire.v1.model.preview_attachment_request import PreviewAttachmentRequest
from lark_oapi.api.hire.v1.model.preview_attachment_response import PreviewAttachmentResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class Attachment(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetAttachmentRequest, option: RequestOption = RequestOption()) -> GetAttachmentResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetAttachmentResponse = JSON.unmarshal(str(resp.content, UTF_8), GetAttachmentResponse)
        response.raw = resp

        return response

    def preview(self, request: PreviewAttachmentRequest,
                option: RequestOption = RequestOption()) -> PreviewAttachmentResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PreviewAttachmentResponse = JSON.unmarshal(str(resp.content, UTF_8), PreviewAttachmentResponse)
        response.raw = resp

        return response
