# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.im.v1.model.get_chat_moderation_request import GetChatModerationRequest
from lark_oapi.api.im.v1.model.get_chat_moderation_response import GetChatModerationResponse
from lark_oapi.api.im.v1.model.update_chat_moderation_request import UpdateChatModerationRequest
from lark_oapi.api.im.v1.model.update_chat_moderation_response import UpdateChatModerationResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class ChatModeration(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetChatModerationRequest,
            option: RequestOption = RequestOption()) -> GetChatModerationResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetChatModerationResponse = JSON.unmarshal(str(resp.content, UTF_8), GetChatModerationResponse)
        response.raw = resp

        return response

    def update(self, request: UpdateChatModerationRequest,
               option: RequestOption = RequestOption()) -> UpdateChatModerationResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UpdateChatModerationResponse = JSON.unmarshal(str(resp.content, UTF_8), UpdateChatModerationResponse)
        response.raw = resp

        return response
