# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.im.v1.model.list_special_focus_request import ListSpecialFocusRequest
from lark_oapi.api.im.v1.model.list_special_focus_response import ListSpecialFocusResponse
from lark_oapi.api.im.v1.model.unread_special_focus_request import UnreadSpecialFocusRequest
from lark_oapi.api.im.v1.model.unread_special_focus_response import UnreadSpecialFocusResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class SpecialFocus(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def list(self, request: ListSpecialFocusRequest,
             option: RequestOption = RequestOption()) -> ListSpecialFocusResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListSpecialFocusResponse = JSON.unmarshal(str(resp.content, UTF_8), ListSpecialFocusResponse)
        response.raw = resp

        return response

    def unread(self, request: UnreadSpecialFocusRequest,
               option: RequestOption = RequestOption()) -> UnreadSpecialFocusResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UnreadSpecialFocusResponse = JSON.unmarshal(str(resp.content, UTF_8), UnreadSpecialFocusResponse)
        response.raw = resp

        return response
