# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.mail.v1.model.create_user_mailbox_alias_request import CreateUserMailboxAliasRequest
from lark_oapi.api.mail.v1.model.create_user_mailbox_alias_response import CreateUserMailboxAliasResponse
from lark_oapi.api.mail.v1.model.delete_user_mailbox_alias_request import DeleteUserMailboxAliasRequest
from lark_oapi.api.mail.v1.model.delete_user_mailbox_alias_response import DeleteUserMailboxAliasResponse
from lark_oapi.api.mail.v1.model.list_user_mailbox_alias_request import ListUserMailboxAliasRequest
from lark_oapi.api.mail.v1.model.list_user_mailbox_alias_response import ListUserMailboxAliasResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class UserMailboxAlias(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateUserMailboxAliasRequest,
               option: RequestOption = RequestOption()) -> CreateUserMailboxAliasResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateUserMailboxAliasResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  CreateUserMailboxAliasResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteUserMailboxAliasRequest,
               option: RequestOption = RequestOption()) -> DeleteUserMailboxAliasResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteUserMailboxAliasResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  DeleteUserMailboxAliasResponse)
        response.raw = resp

        return response

    def list(self, request: ListUserMailboxAliasRequest,
             option: RequestOption = RequestOption()) -> ListUserMailboxAliasResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListUserMailboxAliasResponse = JSON.unmarshal(str(resp.content, UTF_8), ListUserMailboxAliasResponse)
        response.raw = resp

        return response
