# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.mdm.v1.model.bind_user_auth_data_relation_request import BindUserAuthDataRelationRequest
from lark_oapi.api.mdm.v1.model.bind_user_auth_data_relation_response import BindUserAuthDataRelationResponse
from lark_oapi.api.mdm.v1.model.unbind_user_auth_data_relation_request import UnbindUserAuthDataRelationRequest
from lark_oapi.api.mdm.v1.model.unbind_user_auth_data_relation_response import UnbindUserAuthDataRelationResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class UserAuthDataRelation(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def bind(self, request: BindUserAuthDataRelationRequest,
             option: RequestOption = RequestOption()) -> BindUserAuthDataRelationResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BindUserAuthDataRelationResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    BindUserAuthDataRelationResponse)
        response.raw = resp

        return response

    def unbind(self, request: UnbindUserAuthDataRelationRequest,
               option: RequestOption = RequestOption()) -> UnbindUserAuthDataRelationResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UnbindUserAuthDataRelationResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                      UnbindUserAuthDataRelationResponse)
        response.raw = resp

        return response
