# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.task.v1.model.create_task_reminder_request import CreateTaskReminderRequest
from lark_oapi.api.task.v1.model.create_task_reminder_response import CreateTaskReminderResponse
from lark_oapi.api.task.v1.model.delete_task_reminder_request import DeleteTaskReminderRequest
from lark_oapi.api.task.v1.model.delete_task_reminder_response import DeleteTaskReminderResponse
from lark_oapi.api.task.v1.model.list_task_reminder_request import ListTaskReminderRequest
from lark_oapi.api.task.v1.model.list_task_reminder_response import ListTaskReminderResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class TaskReminder(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateTaskReminderRequest,
               option: RequestOption = RequestOption()) -> CreateTaskReminderResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateTaskReminderResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateTaskReminderResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteTaskReminderRequest,
               option: RequestOption = RequestOption()) -> DeleteTaskReminderResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteTaskReminderResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteTaskReminderResponse)
        response.raw = resp

        return response

    def list(self, request: ListTaskReminderRequest,
             option: RequestOption = RequestOption()) -> ListTaskReminderResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListTaskReminderResponse = JSON.unmarshal(str(resp.content, UTF_8), ListTaskReminderResponse)
        response.raw = resp

        return response
