# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.vc.v1.model.create_scope_config_request import CreateScopeConfigRequest
from lark_oapi.api.vc.v1.model.create_scope_config_response import CreateScopeConfigResponse
from lark_oapi.api.vc.v1.model.get_scope_config_request import GetScopeConfigRequest
from lark_oapi.api.vc.v1.model.get_scope_config_response import GetScopeConfigResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class ScopeConfig(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateScopeConfigRequest,
               option: RequestOption = RequestOption()) -> CreateScopeConfigResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateScopeConfigResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateScopeConfigResponse)
        response.raw = resp

        return response

    def get(self, request: GetScopeConfigRequest, option: RequestOption = RequestOption()) -> GetScopeConfigResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetScopeConfigResponse = JSON.unmarshal(str(resp.content, UTF_8), GetScopeConfigResponse)
        response.raw = resp

        return response
