# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.api.wiki.v2.model.create_space_member_request import CreateSpaceMemberRequest
from lark_oapi.api.wiki.v2.model.create_space_member_response import CreateSpaceMemberResponse
from lark_oapi.api.wiki.v2.model.delete_space_member_request import DeleteSpaceMemberRequest
from lark_oapi.api.wiki.v2.model.delete_space_member_response import DeleteSpaceMemberResponse
from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify


class SpaceMember(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def create(self, request: CreateSpaceMemberRequest,
               option: RequestOption = RequestOption()) -> CreateSpaceMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateSpaceMemberResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateSpaceMemberResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteSpaceMemberRequest,
               option: RequestOption = RequestOption()) -> DeleteSpaceMemberResponse:
        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteSpaceMemberResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteSpaceMemberResponse)
        response.raw = resp

        return response
